PROGRAM FDCOPIER ;

{ Program to give you the choice of copying or not copying a folder }
{ to a ramdisk. Best used in a AUTO folder.                         }

{ The folder PATHNAME and ram disk LETTER are named in a text file  }
{ named FDCOPIER.INF on the root of disk A.                         }

{ Written by William R. Good Oct. 1986 in Personal Pascal from OSS. }
{ Released to public domain                                         }




  CONST
    chunk_size = 4096 ;
    infoname = 'A:\FDCOPIER.INF' ;
    wait_time = 45000 ;

  TYPE
    buffer_type = PACKED ARRAY [ 1..chunk_size ] OF byte ;
    file_name = PACKED ARRAY [ 1..14 ] of CHAR ;
    path_name = PACKED ARRAY [ 1..64 ] of CHAR ;
    tftype = FILE OF TEXT ;
    frec = PACKED RECORD
             reserved : PACKED ARRAY [ 0..19 ] OF byte ;
             resvd2 : byte ;
             attrib : byte ;
             time_stamp : integer ;
             date_stamp : integer ;
             size : long_integer ;
             filename : file_name ;
           END ;


  VAR
    temp_string, path_string : STRING ;
    inpath, outpath : STRING ;
    pressed, keyboard : integer ;
    test, in_file, out_file : integer ;
    buf : buffer_type ;
    name, pathname : path_name ;
    fileinfo : frec ;

{ GEMDOS procedures and functions defined here                      }

PROCEDURE set_dta( VAR buffer : frec ) ;
   GEMDOS ( $1a ) ;

FUNCTION get_first( VAR path : path_name ; search_attrib :integer ):integer ;
   GEMDOS ( $4e ) ;

FUNCTION get_next : integer ;
   GEMDOS ( $4f ) ;

FUNCTION gem_create( VAR path : path_name ; mode : integer ) : integer;
  GEMDOS( $3C ) ;

FUNCTION gem_open( VAR path: path_name ; mode : integer ) : integer;
  GEMDOS( $3D ) ;

PROCEDURE gem_close( handle : integer ) ;
  GEMDOS( $3E ) ;

FUNCTION gem_read( handle : integer ; nbytes : long_integer ;
              VAR buf : buffer_type ) : long_integer ;
  GEMDOS( $3F ) ;

FUNCTION gem_write( handle : integer ; nbytes : long_integer ;
              VAR buf : buffer_type ) : long_integer ;
  GEMDOS( $40 ) ;

PROCEDURE gem_seek( nbytes : long_integer ; handle, mode : integer ) ;
  GEMDOS( $42 ) ;

{ BIOS functions and procedures defined here                         }

FUNCTION bconstat( dev : integer ) : integer ; { returns input device status }
  BIOS( $01 ) ;


PROCEDURE write_info ;
   VAR
      dummy : integer ;

   BEGIN
     writeln ;
     writeln ('FDCOPIER : A folder to ramdisk copier') ;
     writeln ('by Willaim R. Good Oct. 86') ;
     writeln ('Released to public domain') ;
     writeln ;
     writeln ('Portions of this product are') ;
     writeln ('Copyright (c) 1986 OSS and CCD') ;
     writeln ('Used by Permission of OSS') ;
     writeln ;
     writeln ('To skip copying press any key') ;
     writeln ('You have five seconds') ;
   END ;

PROCEDURE get_status( VAR status : integer; device : integer ) ;
   VAR
      times : long_integer ;

   BEGIN
      times := 1 ;
      status := 0 ;
      repeat
         status := bconstat(2) ;
         times := times + 1 ;
      until ( times >= wait_time ) or ( status = -1 ) ;
   END ; { get status }

PROCEDURE copy_info( VAR pathin : string ; VAR pathout : string ) ;
   VAR
      textfile : tftype ;

   BEGIN
      writeln ;
      writeln ('            COPYING      ') ;
      writeln ;
      reset ( textfile, infoname ) ;
      readln ( textfile, inpath ) ;
      readln ( textfile, outpath ) ;
      close ( textfile ) ;
      writeln ( 'from FOLDER  :  ', inpath ) ;
      writeln ( 'to  RAMDISK  :  ', outpath ) ;
      writeln ;
   END ;

PROCEDURE copy_file( in_file, out_file : integer ) ;

    VAR
      numofbytes : long_integer ;

    BEGIN
      REPEAT
        gem_close( out_file ) ;         { Close down the output! }
        out_file := gem_open( name, 1 ) ;
        gem_seek( 0, out_file, 2 ) ;    { Seek end-of-file }
        numofbytes := gem_read( in_file, chunk_size, buf ) ;
        IF numofbytes < 0 THEN
          BEGIN
            writeln( 'error ', numofbytes, ' on input file' ) ;
            halt ;
          END
        ELSE IF numofbytes > 0 THEN
          IF gem_write( out_file, numofbytes, buf ) <> numofbytes THEN
            BEGIN
              writeln( 'error writing output file' ) ;
              halt ;
            END ;
      UNTIL numofbytes = 0 ;
    END ; {copy_file}


  PROCEDURE get_name( VAR fileinfo : frec ) ;

    VAR
       place : integer ;
       infostr, testname,
       inname, outname : string ;

    BEGIN
       WITH fileinfo DO
          BEGIN
             place := 1 ;
             testname := '' ;
             WHILE (place <=14) AND (filename[place] <> chr(0)) DO
                BEGIN
                   testname := concat(testname,filename[place]) ;
                   place := place + 1 ;
                END ;
             inname := concat( inpath, testname ) ;
             outname := concat( outpath, testname ) ;
             FOR place := 1 TO length( inname ) DO
                name[place] := inname[place] ;
             name[ length(inname) + 1 ] := chr(0) ;
             in_file  := gem_open( name, 0 ) ;
             IF in_file < 0 THEN
                BEGIN
                   writeln( 'error ', in_file, ' opening input' ) ;
                   halt ;
                END ;
             FOR place := 1 TO length( outname ) DO
                name[place] := outname[place] ;
             name[ length(outname) + 1 ] := chr(0) ;
             out_file := gem_create( name, 0 ) ;
             IF out_file < 0 THEN
                BEGIN
                   writeln( 'error ', out_file, ' opening output' ) ;
                   halt ;
                END ;
            writeln( testname ) ;
            copy_file( in_file, out_file ) ;
            gem_close( in_file ) ;
            gem_close( out_file ) ;

          END ;
    END ; {get_name}

  BEGIN  { MAIN MODULE }
     write_info ;
     get_status ( pressed, keyboard ) ; { get status of keyboard }
     if pressed > -1 then
        begin
           copy_info( inpath, outpath ) ;
           path_string := concat( inpath, '*.*' ) ;

           FOR test := 1 to length( path_string ) do
              pathname[test] := path_string[test] ;
           pathname[ length(path_string)+1 ] := chr(0) ;
           set_dta( fileinfo ) ;
           IF get_first( pathname, 0 ) < 0 then
              writeln ( 'no files match specification!' )
           ELSE
              REPEAT
                 get_name( fileinfo ) ;
              UNTIL get_next < 0 ;
        end
     else
  END. { FDCOPIER }
